using meowlang.parser.antlr;

namespace meowlang.parser;

public class AttributeValueVisitorNya : MeowBaseVisitorNya<AttributeValueModel>
{
    public override AttributeValueModel VisitAttributeValue(MeowParser.AttributeValueContext context)
    {
        if (context.id != null)
        {
            return new IdentifierAttributeValueModel(context.GetSpan(), context.id.Text);
        }

        var literal = new LiteralVisitorNya().Visit(context.literal());
        return new LiteralAttributeValueModel(context.GetSpan(), literal);
    }
}