using meowlang.parser.antlr;

namespace meowlang.parser;

public class EnumMemberVisitorNya : MeowBaseVisitorNya<EnumMemberModel>
{
    public override EnumMemberModel VisitEnumMember(MeowParser.EnumMemberContext context)
    {
        var name = context.name.Text;

        TypeReferenceModel? type = null;
        var typeRef = context.typeReference();
        if (typeRef != null)
        {
            type = new TypeReferenceVisitorNya().Visit(typeRef);
        }

        return new EnumMemberModel(context.GetSpan(), name, type);
    }
}