namespace meowlang.parser;

public record IfExpressionModel(Span Span, ExpressionModel Condition, BlockExpressionModel Block,
    List<(ExpressionModel Condition, BlockExpressionModel Block)> IfElses,
    BlockExpressionModel? Else) : ExpressionModel(Span)
{
    public override IEnumerable<ModelBase> GetChildren()
    {
        foreach (var modelBase in base.GetChildren())
        {
            yield return modelBase;
        }

        foreach (var (condition, block) in IfElses)
        {
            yield return condition;
            yield return block;
        }
    }
}