using Antlr4.Runtime;
using meowlang.parser.antlr;

namespace meowlang.parser;

public class Parser
{
    public static Model? Parse(string path)
    {
        var lexer = new MeowLexer(new AntlrFileStream(path));
        var tokenStream = new CommonTokenStream(lexer);
        var parser = new MeowParser(tokenStream);
        var visitor = new VisitorNya();
        var file = parser.file();
        if (parser.NumberOfSyntaxErrors > 0)
        {
            return null;
        }
        return visitor.Visit(file);
    }
}