namespace meowlang.parser;

public record SwitchExpressionModel(Span Span, ExpressionModel Expression,
    List<(LiteralModel Value, ExpressionModel? Body)> Cases, ExpressionModel? Default) : ExpressionModel(Span)
{
    public override IEnumerable<ModelBase> GetChildren()
    {
        foreach (var modelBase in base.GetChildren())
        {
            yield return modelBase;
        }

        foreach (var (condition, block) in Cases)
        {
            yield return condition;
            if (block != null) yield return block;
        }
    }
}