namespace meowlang.parser;

public static class UnaryOperatorExtensions
{
    public static UnaryOperator ToUnaryOperator(this string str) => str switch
    {
        "!" => UnaryOperator.LogicalNot,
        "~" => UnaryOperator.BitwiseNot,
        "-" => UnaryOperator.Negative,
    };

    public static string ToString(this UnaryOperator op) => op switch
    {
        UnaryOperator.LogicalNot => "!",
        UnaryOperator.BitwiseNot => "~",
        UnaryOperator.Negative => "-",
    };
}