namespace meowlang.typechecker;

public record GenericArrayTypeDescription : GenericTypeDescription
{
    private readonly GenericTypeId _elementType;
    private readonly uint _size;

    public GenericArrayTypeDescription(List<string> genericNames, GenericTypeId elementType, uint size) : base(genericNames)
    {
        _elementType = elementType;
        _size = size;
    }
    
    public override ArrayTypeDescription Concretize(List<Guid> typeParams)
    {
        return new ArrayTypeDescription(ConcretizeGenericType(_elementType, typeParams), _size);
    }
}